import java.io.*;
import java.util.*;


public class SaimoeLot2{
	public static void main(String[] args)throws IOException{
		/*
			a
			gF
			java SaimoeLot2 (1)̃t@C (2)̃t@C sς݃R[h̃t@C
			
			(1){io҂A1\I01g1ʁA01g2ʁEEE01g8ʁA02g1ʁEEE18g8ʁA
			@2\I01g1ʁA01g2ʁEEE01g16ʁA02g1ʁEEE09g16ʁA
			@ׂXg쐬Biꍇ͂̓̏Wvʂ̃Xgɏ]j
			
			(2)8/523F00܂łɗ񋟎҂A001`300x̐1s1uA_ɕבւ
			@txtt@CiXgaƂjApXtzipkŃAbv[_[ɏグB
			a
		*/
		Scanner nameScanner = new Scanner(new FileReader(args[0]));
		Scanner numberScanner = new Scanner(new FileReader(args[1]));
		Scanner codeScanner = new Scanner(new FileReader(args[2]));
		
		/*
			a
			(3){ioҊmA񋟎҂(1)̃XgƃXgaExcelɕׁAXga̗]
			@ŃXgȁŕבւB
			a
		*/
		ArrayList<StringPair> numberAndNameList = new ArrayList<StringPair>();
		while(nameScanner.hasNext()){
			numberAndNameList.add(new StringPair(String.format("%04d", numberScanner.nextInt()), nameScanner.next()));
		}
		Collections.sort(numberAndNameList);
		
		/*
			a
			(4)̑O
			(4)ɁA8/5̃R[hsL^288iꍇ͂̕]Ɂj
			@oA
			
			a
		*/
		ArrayList<String> codeList = new ArrayList<String>();
		while(codeScanner.hasNext()){
			codeList.add(codeScanner.next());
		}
		
		/*
			a
			(4)̌㔼
			L̃Xg̗̉ExcelŕׂB̌AR[hsXg̏ŕבւB
			a
		*/
		ArrayList<StringPair> codeAndNameList = new ArrayList<StringPair>();
		for(int i = 0; i < numberAndNameList.size(); i++){
			codeAndNameList.add(new StringPair(codeList.get(i + codeList.size() - numberAndNameList.size()), numberAndNameList.get(i).value));
		}
		Collections.sort(codeAndNameList);
		
		/*
			a
			(5)̑O
			(5)בւXg̏ォ珇AubN11lځ`3lځA21lځ`3lځEEE
			@121lځ`3lځABubN11lځ`3lځEEEHubN121lځ`3l
			@ƓĂ͂߂B
			a
		*/
		int index = 0;
		for(int blockIndex = 1; blockIndex <= 8; blockIndex++){
			for(int matchIndex = 1; matchIndex <= 12; matchIndex++){
				for(int charaIndex = 1; charaIndex <= 3; charaIndex++){
					System.out.println((char)('A' + blockIndex - 1) + "ubN" + matchIndex + "" + charaIndex + "lځF" + codeAndNameList.get(index).value);
					index++;
				}
				System.out.println();
			}
			System.out.println("================================================");
		}
		/*
			a
			(5)̌㔼
			289lڈȍ~ꍇ́AAubN14lځEEEHubN14lځA
			@AubN84lځEEEHubN84lځAƑ}B		
			a
		*/
		
		System.out.println(index);
		for(; index < codeAndNameList.size(); index++){
			int num = index - 288;
			int blockIndex = num % 8;
			num /= 8;
			int matchIndex = num % 12 + 1;
			num /= 12;
			int charaIndex = num + 4;
			System.out.println((char)('A' + blockIndex) + "ubN" + matchIndex + "" + charaIndex + "lځF" + codeAndNameList.get(index).value);
		}
	}
}

class StringPair implements Comparable<StringPair>{
	String key;
	String value;
	
	StringPair(String _key, String _value){
		key = _key;
		value = _value;
	}
	
	public int compareTo(StringPair sp){
		return(this.key.compareToIgnoreCase(sp.key));
	}
}
